//
// Global constants
//

var my_module_image_height = 64;
var app_name = 'Best VoIP Rate';
var app_ver = '2.1.3';
var app_market_link = 'com.kteknoloji.bestvoiprate';
var app_web_link = 'http://www.bestvoiprate.com';

var user_language = 2;
var my_module_image_height = 30;
var html = '';
var default_sort_order = 1;
var current_orientation = "";

var show_portrait_landline = 1;
var show_portrait_mobile = 1;
var show_portrait_sms = 1;
var show_portrait_landline2 = 0;
var show_portrait_mobile2 = 0;
var show_landscape_landline = 1;
var show_landscape_mobile = 1;
var show_landscape_sms = 1;
var show_landscape_landline2 = 1;
var show_landscape_mobile2 = 1;


//
// CSS
//

function my_module_install() {
  try {
    var css = drupalgap_get_path('module', 'my_module') + '/my_module.css';
    drupalgap_add_css(css);
  }
  catch (error) { console.log('my_module_install - ' + error); }
}


//
// Sliding Menu Items
//

function my_module_block_info() {
  try {
    var blocks = {};
    blocks['my_panel_block'] = {
      delta: 'my_panel_block',
      module: 'my_module'
    };
    blocks['my_panel_block_button'] = {
      delta: 'my_panel_block_button',
      module: 'my_module'
    };
    return blocks;
  }
  catch (error) { console.log('my_module_block_info - ' + error); }
}

function my_module_block_view(delta, region) {
  try {
    var content = '';
    switch (delta) {
      // The slide menu (aka panel).
      case 'my_panel_block':
        var attrs = {
          id: drupalgap_panel_id(delta),
          'data-role': 'panel',
          'data-position': 'left', // left or right
          'data-display': 'overlay' // overlay, reveal or push
//          'data-display': 'reveal' // overlay, reveal or push
//          'data-display': 'push' // overlay, reveal or push
        };
        var items = [
          bl(t('Homepage'), 'home', {
              reloadPage: true,
              attributes: {
                'data-icon': 'home',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t('Providers'), 'providers', {
              attributes: {
                'data-icon': 'location-arrow',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t('Countries'), 'countries', {
              attributes: {
                'data-icon': 'shopping-cart',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t('Settings'), 'settings', {
              reloadPage: true,
              attributes: {
                'data-icon': 'gear',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
/*
          bl(t('Contact'), 'node/67', {
              reloadPage: true,
              attributes: {
                'data-icon': 'comment-o',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
*/
          bl(t('Rate us'), null, {
              attributes: {
                'data-icon': 'star',
               	onclick: "window.open('market://details?id=com.kteknoloji.bestvoiprate', '_system', 'location=yes')",
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t('Visit website'), null, {
              attributes: {
                'data-icon': 'globe',
               	onclick: "window.open('https://www.bestvoiprate.com', '_system', 'location=yes')",
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t('About'), 'about', {
              attributes: {
                'data-icon': 'info-circle',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t('Exit'), 'exit', {
              attributes: {
                'data-icon': 'power',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
        ];
        content += '<div ' + drupalgap_attributes(attrs) + '>' +
          '<!-- panel content goes here -->' +
          theme('jqm_item_list', { items: items }) +
        '</div><!-- /panel -->';
        break;
      // The button to open the menu.
      case 'my_panel_block_button':
        content = bl('Open panel', '#' + drupalgap_panel_id('my_panel_block'), {
            attributes: {
              'data-icon': 'bars',
              'data-iconpos': 'notext',
              'class': 'ui-btn-left',
              onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
            }
        });
        break;
    }
    return content;
  }
  catch (error) { console.log('my_module_block_view - ' + error); }
}

function my_module_menu() {	
  var items = {};

  items['offline'] = {
    title: t('Offline'),
    page_callback: 'my_module_offline_page'
  };

  items['home'] = {
    title: app_name,
    page_callback: 'my_module_home_page',
		options: { reloadPage: true }
  };

  items['providers'] = {
    title: 'Providers',
    page_callback: 'my_module_providers_page',
		options: { reloadPage: true }
  };

  items['provider/%'] = {
    title: 'Rates for %',
    page_callback: 'my_module_provider_page',
    page_arguments: [1],
    title_callback: 'my_module_provider_page_title_callback',
    title_arguments: [1],
  };

  items['provider-rates/%'] = {
    title: 'Rates for %',
    page_callback: 'my_module_provider_rates_page',
    page_arguments: [1],
    title_callback: 'my_module_provider_rates_page_title_callback',
    title_arguments: [1],
		options: { reloadPage: true }
  };

  items['countries'] = {
    title: 'Countries',
    page_callback: 'my_module_countries_page',
		options: { reloadPage: true }
  };

  items['country/%'] = {
    title: 'Rates for %',
    page_callback: 'my_module_country_page',
    page_arguments: [1],
    title_callback: 'my_module_country_page_title_callback',
    title_arguments: [1],
  };

  items['country-rates/%'] = {
    title: 'Rates for %',
    page_callback: 'my_module_country_rates_page',
    page_arguments: [1],
    title_callback: 'my_module_country_rates_page_title_callback',
    title_arguments: [1],
    options: { reloadPage: true }
  };

  items['make-favourite/%'] = {
    title: 'Favourite',
    page_callback: 'my_module_make_favourite_page',
    page_arguments: [1],
  };

	items['settings'] = {
		title: t('Settings'),
		page_callback: 'drupalgap_get_form',
		page_arguments: ['my_module_settings_form'],
		options: { reloadPage: true }
	};

  items['about'] = {
    title: t('About'),
    page_callback: 'my_module_about_page',
  };

  items['exit'] = {
    title: t('Exit'),
    page_callback: 'my_module_exit_page',
  };

  return items;
}

function my_module_home_page() {
  try {
    var max_col = 4;
    var grid_type = 'c';
    var pos = 0;    
    var content = {};
    content['button1'] = {
      theme: 'markup',
      markup: '<div class="ui-grid-'+grid_type+' my-breakpoint-'+max_col+'">'+
              '  <div class="ui-block-'+grid_func(pos++, max_col)+'">'+
                button_image_link(t('Providers'), drupalgap_get_path('module', 'my_module')+'/pictures/voip-providers.png', 'providers')+
              '  </div>',
    }
    content['button2'] = {
      theme: 'markup',
      markup: '<div class="ui-block-'+grid_func(pos++, max_col)+'">'+
                button_image_link(t('Countries'), drupalgap_get_path('module', 'my_module')+'/pictures/countries.png', 'countries')+
              '</div>',
    }
    content['button5'] = {
      theme: 'markup',
      markup: '<div class="ui-block-'+grid_func(pos++, max_col)+'">'+
                button_image_link(t('About'), drupalgap_get_path('module', 'my_module')+'/pictures/info.png', 'about')+
              '</div>',
    }
    content['button6'] = {
      theme: 'markup',
      markup: '<div class="ui-block-'+grid_func(pos++, max_col)+'">'+
                button_image_link(t('Settings'), drupalgap_get_path('module', 'my_module')+'/pictures/settings.png', 'settings')+
              '</div>',
    }
    content['end'] = {
      theme: 'markup',
      markup: '</div>',
    }
    return content; 
  }  catch (error) { console.log('my_module_home_page - ' + error); }
}

function my_module_about_page() {
  try {
    window.analytics.trackView('About Page');

    var content = {};
    content['about_page'] = {
      markup: '<div style="text-align: center;">'+
							'  <img src=images/logo.png>'+
							'  <h3>'+app_name+' '+app_ver+'</h3>'+
							'</div>'+
      '<strong>'+app_name+'</strong> is an application that helps you to find cheapest VoIP provider companies. '+
      '<strong>'+app_name+'</strong> application gets data from <strong>www.BestVoipRate.com</strong> website.'+
      '<p>'+
      'With <strong>'+app_name+'</strong>, you will find rates by provider and by country.'+
      '<p>'+
      'In future, you will be able to follow rate changes with mobile notification and/or e-mail.'+
              '<br><br>'+
              '<div class="ui-grid-b">'+
              '  <div class="ui-block-a">'+
                  bl(draw_button(t('Share'), drupalgap_get_path('module', 'my_module') + '/pictures/share.png', my_module_image_height), null, {
                    attributes: {
                      onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                      onClick: "window.plugins.socialsharing.share('"+t('I recommend you to use this mobile application:')+" ', null, null, 'https://play.google.com/store/apps/details?id=com.kteknoloji.bestvoiprate')"
                    }
                  })+
              '  </div>'+
              '  <div class="ui-block-b">'+
                  bl(draw_button(t('Rate'), drupalgap_get_path('module', 'my_module') + '/pictures/rate.png', my_module_image_height), null, {
                    attributes: {
                      onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                      onClick: "window.open('https://play.google.com/store/apps/details?id=com.kteknoloji.bestvoiprate', '_system', 'location=yes')"
                    }
                  })+
              '  </div>'+
              '  <div class="ui-block-c">'+
                  bl(draw_button(t('Website'), drupalgap_get_path('module', 'my_module') + '/pictures/link.png', my_module_image_height), null, {
                    attributes: {
                      onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                      onClick: "window.open('https://www.bestvoiprate.com', '_system', 'location=yes')"
                    }
                  })+
              '  </div>'+
              '</div>',
    };
    return content;
  }  catch (error) { console.log('my_module_about_page - ' + error); }
}

function my_module_exit_page() {
  try {
    navigator.app.exitApp();
  }  catch (error) { console.log('my_module_exit_page - ' + error); }
}


/* Providers */

function my_module_providers_page() {
  try {
    window.analytics.trackView('Providers');
    my_module_check_orientation();
		var content = {};

    content['providers'] = {
      theme: 'view',
      pager_pos: 'bottom',
      format: 'unformatted_list',
      path: 'mobile/voip-providers',
      row_callback: 'my_module_providers_list_row',
      empty_callback: 'my_module_providers_list_empty',
      attributes: {
        id: 'my_providers_list_view'
      }
    };
		return content;
	}
  catch (error) { console.log('my_module_providers_page - ' + error); }
}

function my_module_providers_list_row(view, row) {
  try {   
    var last = false;
    if (view.page * view.limit + row._position == view.count - 1) 
      last = true;
    else if (row._position == view.limit - 1) 
      last = true;

    var grid_type = 'c';
    var max_col = 4;
    if (row._position == 0)
      html = '<div class="ui-grid-'+grid_type+' my-breakpoint-'+max_col+'">';
    html += '  <div class="ui-block-'+grid_func(row._position, max_col)+'">';

    var b = '';
    if (row.logo.src)
      b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
          ' <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+row.logo.src+'>'+
          '</div>';
    b += '<div style="text-align: center;">'+row.title+'</div>';
//alert(title_to_link(row.title));
    html += bl(b, 'provider/'+title_to_link(row.title), {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }});
    html += '</div>';
    if (last) {
      html += '</div>';
      return html;
    } else
      return '';
  }
  catch (error) { console.log('my_module_providers_list_row - ' + error); }
}

function my_module_providers_list_empty(view) {
  try {
    return '<p>'+t('No providers were found.')+'</p>';
  }
  catch (error) { console.log('my_module_providers_list_empty - ' + error); }
}


/* Provider */

function my_module_provider_page(provider) {
  try {
    window.analytics.trackView('Provider: '+link_to_title(provider));
//    var provider_term = title_to_term(provider);
		var content = {};
    content['provider'] = {
      theme: 'view',
      format: 'image',
      path: 'mobile/voip-provider/'+link_to_term(provider),
      row_callback: 'my_module_provider_list_row',
      empty_callback: 'my_module_provider_list_empty',
      attributes: {
        id: 'my_provider_list_view'+provider
      }
    };
		return content;
	}
  catch (error) { console.log('my_module_provider_page - ' + error); }
}

function my_module_provider_list_row(view, row) {
  try {
    my_module_check_orientation();
    var grid = 'a';
    var col = 2;
    if (current_orientation == 'landscape') {
      grid = 'b';
      col = 3;
    }

    html =  '<div style="text-align: center;"><h3>'+row.title+'</h3></div>';
    html += '<div class="ui-grid-'+grid+'">';
    html += '  <div class="ui-block-'+grid_func(0, col)+'">';
    var b = '';
    if (row.logo.src)
      b = '<div style="width: 100%; height: 80px; position: relative">'+
          ' <img style="vertical-align: middle; max-height: 80;" src='+row.logo.src+'>'+
          '</div>';
    html += b;
    html += '  </div>';

    html += '  <div class="ui-block-'+grid_func(1, col)+'">';
    html += bl(draw_button(t('Website'), drupalgap_get_path('module', 'my_module') + '/pictures/link.png', my_module_image_height), null, {
                    attributes: {
                      onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                      onClick: "window.open('"+row.website+"', '_system', 'location=yes')"
                    }
                  });
    html += '  </div>';

    html += '  <div class="ui-block-'+grid_func(2, col)+'">';
    html +=      bl(draw_button(t('Rates'), drupalgap_get_path('module', 'my_module') + '/pictures/rates.png', my_module_image_height), 'provider-rates/'+title_to_link(row.title), {
                    attributes: {
                      onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                    }
                  });
    html += '  </div>';

    html += '  <div class="ui-block-'+grid_func(3, col)+'">';
    html += bl(draw_button(t('Make favourite'), drupalgap_get_path('module', 'my_module') + '/pictures/rate.png', my_module_image_height), 'make-favourite/'+title_to_link(row.title), {
                    attributes: {
                      onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                    }
                  });
    html += '  </div>';
    
    html += '  <div class="ui-block-'+grid_func(4, col)+'">';
    html += '    <div style="text-align: left;">'+t('Currency')+': '+row.currency+'</div>';
    html += '  </div>';

    html += '</div>';
    return html;
  }
  catch (error) { console.log('my_module_provider_list_row - ' + error); }
}

function my_module_provider_list_empty(view) {
  try {
    return '<p>'+t('No provider was found.')+'</p>';
  }
  catch (error) { console.log('my_module_provider_list_empty - ' + error); }
}


/* Provider Rates */

function my_module_provider_rates_page(provider) {
  try {
    window.analytics.trackView('Provider Rate: '+link_to_title(provider));
//    var provider_term = title_to_term(provider);
    var sort_order = '';
    switch (default_sort_order) {
      case '1': sort_order = ''; break;
      case '2': sort_order = '-landline'; break;
      case '3': sort_order = '-mobile'; break;
      case '4': sort_order = '-sms'; break;
      case '5': sort_order = '-landline2'; break;
      case '6': sort_order = '-mobile2'; break;
    }
		var content = {};
    content['provider_rates'] = {
      theme: 'view',
      pager_pos: 'bottom',
      format: 'unformatted_list',
      path: 'mobile/rate'+sort_order+'/'+link_to_term(provider),
      row_callback: 'my_module_provider_rates_list_row',
      empty_callback: 'my_module_provider_rates_list_empty',
      attributes: {
        id: 'my_provider_rates_list_view'+provider
      }
    };
		return content;
	}
  catch (error) { console.log('my_module_provider_rates_page - ' + error); }
}

function my_module_provider_rates_list_row(view, row) {
  try {
    my_module_check_orientation();
    var last = false;
    if (view.page * view.limit + row._position == view.count - 1) 
      last = true;
    else if (row._position == view.limit - 1) 
      last = true;

    if (row._position == 0) {
      html = '<div style="text-align: center;"><h2>'+row.provider+'</h2></div>'+
             '<table style="border: 1px solid black; border-spacing: 0px; padding: 0px;">'+
             '<tr>'+
             '  <th style="border: 1px solid black;">'+t('Country')+'</th>';
      if ((current_orientation == 'portrait' && show_portrait_landline == 1) || (current_orientation == 'landscape' && show_landscape_landline == 1))
        html += '  <th style="border: 1px solid black;">'+t('Land.')+'</th>';
      if ((current_orientation == 'portrait' && show_portrait_mobile == 1) || (current_orientation == 'landscape' && show_landscape_mobile == 1))
        html += '  <th style="border: 1px solid black;">'+t('Mobi.')+'</th>';
      if ((current_orientation == 'portrait' && show_portrait_sms == 1) || (current_orientation == 'landscape' && show_landscape_sms == 1))
        html += '  <th style="border: 1px solid black;">'+t('SMS')+'</th>';
      if ((current_orientation == 'portrait' && show_portrait_landline2 == 1)  || (current_orientation == 'landscape' && show_landscape_landline2 == 1))
        html += '  <th style="border: 1px solid black;">'+t('Land*')+'</th>';
      if ((current_orientation == 'portrait' && show_portrait_mobile2 == 1)  || (current_orientation == 'landscape' && show_landscape_mobile2 == 1))
        html += '  <th style="border: 1px solid black;">'+t('Mobi*')+'</th>';
      html += '</tr>';
    }
    html +=  '<tr>'+
             '  <td style="border: 1px solid black;">'+l(row.country, 'country/'+title_to_link(row.country))+'</td>';
    if ((current_orientation == 'portrait' && show_portrait_landline == 1) || (current_orientation == 'landscape' && show_landscape_landline == 1))
      html += '  <td style="border: 1px solid black;">'+row.landline+'</td>';
    if ((current_orientation == 'portrait' && show_portrait_mobile == 1) || (current_orientation == 'landscape' && show_landscape_mobile == 1))
      html += '  <td style="border: 1px solid black;">'+row.mobile+'</td>';
    if ((current_orientation == 'portrait' && show_portrait_sms == 1) || (current_orientation == 'landscape' && show_landscape_sms == 1))
      html += '  <td style="border: 1px solid black;">'+row.sms+'</td>';
    if ((current_orientation == 'portrait' && show_portrait_landline2 == 1)  || (current_orientation == 'landscape' && show_landscape_landline2 == 1))
      html += '  <td style="border: 1px solid black;">'+row.landline2+'</td>';
    if ((current_orientation == 'portrait' && show_portrait_mobile2 == 1)  || (current_orientation == 'landscape' && show_landscape_mobile2 == 1))
      html += '  <td style="border: 1px solid black;">'+row.mobile2+'</td>';
    html += '</tr>';
    if (last) {
      html += '</table>';
      return html;
    } else
      return '';
  }
  catch (error) { console.log('my_module_provider_rates_list_row - ' + error); }
}

function my_module_provider_rates_list_empty(view) {
  try {
    return '<p>'+t('No providers were found.')+'</p>';
  }
  catch (error) { console.log('my_module_provider_rates_list_empty - ' + error); }
}


/* Countries */

function my_module_countries_page() {
  try {
    window.analytics.trackView('Countries');
    my_module_check_orientation();
		var content = {};

    content['countries'] = {
      theme: 'view',
      pager_pos: 'bottom',
      format: 'unformatted_list',
      path: 'mobile/countries',
      row_callback: 'my_module_countries_list_row',
      empty_callback: 'my_module_countries_list_empty',
      attributes: {
        id: 'my_countries_list_view'
      }
    };
		return content;
	}
  catch (error) { console.log('my_module_countries_page - ' + error); }
}

function my_module_countries_list_row(view, row) {
  try {   
    var last = false;
    if (view.page * view.limit + row._position == view.count - 1) 
      last = true;
    else if (row._position == view.limit - 1) 
      last = true;

    var grid = 'c';
    var max_col = 4;
    if (row._position == 0)
      html = '<div class="ui-grid-'+grid+' my-breakpoint-'+max_col+'">';
    html += '  <div class="ui-block-'+grid_func(row._position, max_col)+'">';

    var b = '';
    if (row.flag.src)
      b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
          ' <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+row.flag.src+'>'+
          '</div>';
    b += '<div style="text-align: center;">'+row.title+'</div>';
    html += bl(b, 'country/'+title_to_link(row.title), {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }});
    html += '</div>';
    if (last) {
      html += '</div>';
      return html;
    } else
      return '';
  }
  catch (error) { console.log('my_module_countries_list_row - ' + error); }
}

function my_module_providers_list_empty(view) {
  try {
    return '<p>'+t('No providers were found.')+'</p>';
  }
  catch (error) { console.log('my_module_providers_list_empty - ' + error); }
}


/* Country */

function my_module_country_page(country) {
  try {
    window.analytics.trackView('Country: '+link_to_title(country));
//    var country_term = title_to_term(country);
//    var country_term = link_to_term(country);
		var content = {};
    content['country'] = {
      theme: 'view',
      format: 'image',
      path: 'mobile/country/'+link_to_term(country),
      row_callback: 'my_module_country_list_row',
      empty_callback: 'my_module_country_list_empty',
      attributes: {
        id: 'my_country_list_view'+country
      }
    };
		return content;
	}
  catch (error) { console.log('my_module_country_page - ' + error); }
}

function my_module_country_list_row(view, row) {
  try {
    my_module_check_orientation();
    var grid = 'a';
    var col = 2;
    if (current_orientation == 'landscape') {
      grid = 'b';
      col = 3;
    }

    html =  '<div style="text-align: center;"><h3>'+row.title+'</h3></div>';
    html += '<div class="ui-grid-'+grid+'">';
    html += '  <div class="ui-block-'+grid_func(0, col)+'">';
    var b = '';
    if (row.flag.src)
      b = '<div style="width: 100%; height: 80px; position: relative">'+
          ' <img style="vertical-align: middle; max-height: 80;" src='+row.flag.src+'>'+
          '</div>';
    html += b;
    html += '  </div>';

    html += '  <div class="ui-block-'+grid_func(1, col)+'">';
    html +=      bl(draw_button(t('Rates'), drupalgap_get_path('module', 'my_module') + '/pictures/rates.png', my_module_image_height), 'country-rates/'+title_to_link(row.title), {
                    attributes: {
                      onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                    }
                  });
    html += '  </div>';

    html += '  <div class="ui-block-'+grid_func(2, col)+'">';
    html += bl(draw_button(t('Make favourite'), drupalgap_get_path('module', 'my_module') + '/pictures/rate.png', my_module_image_height), 'make-favourite/'+title_to_link(row.title), {
                    attributes: {
                      onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                    }
                  });
    html += '  </div>';
    
    html += '</div>';
    return html;
  }
  catch (error) { console.log('my_module_country_list_row - ' + error); }
}

function my_module_country_list_empty(view) {
  try {
    return '<p>'+t('No country was found.')+'</p>';
  }
  catch (error) { console.log('my_module_country_list_empty - ' + error); }
}


/* Country Rates */

function my_module_country_rates_page(country) {
  try {
    window.analytics.trackView('Country Rate: '+link_to_title(country));
//    var country_term = title_to_term(country);
//    var country_term = link_to_term(country);
    my_module_check_orientation();

    var sort_order = '';
    switch (default_sort_order) {
      case '1': sort_order = ''; break;
      case '2': sort_order = '-landline'; break;
      case '3': sort_order = '-mobile'; break;
      case '4': sort_order = '-sms'; break;
      case '5': sort_order = '-landline2'; break;
      case '6': sort_order = '-mobile2'; break;
    }
		var content = {};
    content['country_rates'] = {
      theme: 'view',
      pager_pos: 'bottom',
      format: 'unformatted_list',
      path: 'mobile/rate-by-country'+sort_order+'/'+link_to_term(country),
      row_callback: 'my_module_country_rates_list_row',
      empty_callback: 'my_module_country_rates_list_empty',
      attributes: {
        id: 'my_country_rates_list_view'+country
      }
    };
		return content;
	}
  catch (error) { console.log('my_module_country_rates_page - ' + error); }
}

function my_module_country_rates_list_row(view, row) {
  try {   
    var last = false;
    if (view.page * view.limit + row._position == view.count - 1) 
      last = true;
    else if (row._position == view.limit - 1) 
      last = true;

    if (row._position == 0) {
      html = '<div style="text-align: center;"><h2>'+row.country+'</h2></div>'+
             '<table style="border: 1px solid black; border-spacing: 0px; padding: 0px;">'+
             '<tr>'+
             '  <th style="border: 1px solid black;">'+t('Provider')+'</th>';
      if ((current_orientation == 'portrait' && show_portrait_landline == 1) || (current_orientation == 'landscape' && show_landscape_landline == 1))
        html += '  <th style="border: 1px solid black;">'+t('Land.')+'</th>';
      if ((current_orientation == 'portrait' && show_portrait_mobile == 1) || (current_orientation == 'landscape' && show_landscape_mobile == 1))
        html += '  <th style="border: 1px solid black;">'+t('Mobi.')+'</th>';
      if ((current_orientation == 'portrait' && show_portrait_sms == 1) || (current_orientation == 'landscape' && show_landscape_sms == 1))
        html += '  <th style="border: 1px solid black;">'+t('SMS')+'</th>';
      if ((current_orientation == 'portrait' && show_portrait_landline2 == 1)  || (current_orientation == 'landscape' && show_landscape_landline2 == 1))
        html += '  <th style="border: 1px solid black;">'+t('Land*')+'</th>';
      if ((current_orientation == 'portrait' && show_portrait_mobile2 == 1)  || (current_orientation == 'landscape' && show_landscape_mobile2 == 1))
        html += '  <th style="border: 1px solid black;">'+t('Mobi*')+'</th>';
      html += '</tr>';
    }
    html +=  '<tr>'+
             '  <td style="border: 1px solid black;">'+l(row.provider, 'provider/'+title_to_link(row.provider))+'</td>';
    if ((current_orientation == 'portrait' && show_portrait_landline == 1) || (current_orientation == 'landscape' && show_landscape_landline == 1))
      html += '  <td style="border: 1px solid black;">'+row.landline+'</td>';
    if ((current_orientation == 'portrait' && show_portrait_mobile == 1) || (current_orientation == 'landscape' && show_landscape_mobile == 1))
      html += '  <td style="border: 1px solid black;">'+row.mobile+'</td>';
    if ((current_orientation == 'portrait' && show_portrait_sms == 1) || (current_orientation == 'landscape' && show_landscape_sms == 1))
      html += '  <td style="border: 1px solid black;">'+row.sms+'</td>';
    if ((current_orientation == 'portrait' && show_portrait_landline2 == 1)  || (current_orientation == 'landscape' && show_landscape_landline2 == 1))
      html += '  <td style="border: 1px solid black;">'+row.landline2+'</td>';
    if ((current_orientation == 'portrait' && show_portrait_mobile2 == 1)  || (current_orientation == 'landscape' && show_landscape_mobile2 == 1))
      html += '  <td style="border: 1px solid black;">'+row.mobile2+'</td>';
    html += '</tr>';
    if (last) {
      html += '</table>';
      return html;
    } else
      return '';
  }
  catch (error) { console.log('my_module_country_rates_list_row - ' + error); }
}

function my_module_country_rates_list_empty(view) {
  try {
    return '<p>'+t('No countries were found.')+'</p>';
  }
  catch (error) { console.log('my_module_country_rates_list_empty - ' + error); }
}


/* Settings */

function my_module_settings_form(form, form_state) {
  try {
    var p = {};
    if (show_portrait_landline == 1)
      p.landline = t('Landline');
    if (show_portrait_mobile == 1)
      p.mobile = t('Mobile');
    if (show_portrait_sms == 1)
      p.sms = t('SMS');
    if (show_portrait_landline2 == 1)
      p.landline2 = t('Landline OOF');
    if (show_portrait_mobile2 == 1)
      p.mobile2 = t('Mobile OOF');
    var l = {};
    if (show_landscape_landline == 1)
      l.landline = t('Landline');
    if (show_landscape_mobile == 1)
      l.mobile = t('Mobile');
    if (show_landscape_sms == 1)
      l.sms = t('SMS');
    if (show_landscape_landline2 == 1)
      l.landline2 = t('Landline OOF');
    if (show_landscape_mobile2 == 1)
      l.mobile2 = t('Mobile OOF');

    form.elements['default_sort_order'] = {
      title: t('Sort order'),
      type: 'select',
      options: {
        0: t('Please select'),
        1: t('Provider / Country'),
        2: t('Landline'),
        3: t('Mobile'),
        4: t('SMS'),
        5: t('Landline OOF'),
        6: t('Mobile OOF'),
      },
      required: false,
      default_value: default_sort_order,
      attributes: { onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }
    };
    form.elements['portrait_settings'] = {
      title: t('Visible on portrait'),
      type: 'checkboxes',
      required: true,
      options: {
        landline: t('Landline'),
        mobile: t('Mobile'),
        sms: t('SMS'),
        landline2: t('Landline OOF'),
        mobile2: t('Mobile OOF'),
      },
      default_value: p
    };
    form.elements['landscape_settings'] = {
      title: t('Visible on landscape'),
      type: 'checkboxes',
      required: true,
      options: {
        landline: t('Landline'),
        mobile: t('Mobile'),
        sms: t('SMS'),
        landline2: t('Landline OOF'),
        mobile2: t('Mobile OOF'),
      },
      default_value: l
    };
    form.elements['lang'] = {
      title: t('Language'),
      type: 'select',
      options: {
        0: t('Please select'),
        1: t('System default'),
        2: t('Turkish'),
        3: t('English'),
      },
      required: false,
      default_value: user_language,
      attributes: { onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }
    };
    form.elements['submit'] = {
      type: 'submit',
      value: t('Ok'),
      attributes: { onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }
    };

    return form;
  }
  catch (error) { alert(error);console.log('my_module_custom_form - ' + error); }
}

function my_module_settings_form_submit(form, form_state) {
  try {
    default_sort_order = form_state.values['default_sort_order'];
    variable_set('my_module_default_sort_order', default_sort_order);
    
    if (form_state.values.portrait_settings.landline == '0') show_portrait_landline = 0; else show_portrait_landline = 1;
    if (form_state.values.portrait_settings.mobile == '0') show_portrait_mobile = 0; else show_portrait_mobile = 1;
    if (form_state.values.portrait_settings.sms == '0') show_portrait_sms = 0; else show_portrait_sms = 1;
    if (form_state.values.portrait_settings.landline2 == '0') show_portrait_landline2 = 0; else show_portrait_landline2 = 1;
    if (form_state.values.portrait_settings.mobile2 == '0') show_portrait_mobile2 = 0; else show_portrait_mobile2 = 1;

    if (form_state.values.landscape_settings.landline == '0') show_landscape_landline = 0; else show_landscape_landline = 1;
    if (form_state.values.landscape_settings.mobile == '0') show_landscape_mobile = 0; else show_landscape_mobile = 1;
    if (form_state.values.landscape_settings.sms == '0') show_landscape_sms = 0; else show_landscape_sms = 1;
    if (form_state.values.landscape_settings.landline2 == '0') show_landscape_landline2 = 0; else show_landscape_landline2 = 1;
    if (form_state.values.landscape_settings.mobile2 == '0') show_landscape_mobile2 = 0; else show_landscape_mobile2 = 1;

    variable_set('my_module_show_portrait_landline', show_portrait_landline);
    variable_set('my_module_show_portrait_mobile', show_portrait_mobile);
    variable_set('my_module_show_portrait_sms', show_portrait_sms);
    variable_set('my_module_show_portrait_landline2', show_portrait_landline2);
    variable_set('my_module_show_portrait_mobile2', show_portrait_mobile2);
    variable_set('my_module_show_landscape_landline', show_landscape_landline);
    variable_set('my_module_show_landscape_mobile', show_landscape_mobile);
    variable_set('my_module_show_landscape_sms', show_landscape_sms);
    variable_set('my_module_show_landscape_landline2', show_landscape_landline2);
    variable_set('my_module_show_landscape_mobile2', show_landscape_mobile2);

    if (user_language != form_state.values['lang']) {
      user_language = form_state.values['lang'];
      variable_set('my_module_user_language', user_language);
      change_language();
    }

    alert(t('Settings saved'));
    drupalgap_goto('home');
  }
  catch (error) { console.log('my_module_custom_form_submit - ' + error); }
}


/* Favourite */

function my_module_make_favourite_page() {
  try {
    window.analytics.trackView('Favourite Page');

    var content = {};
    content['favourite_page'] = {
      theme: 'markup',
      markup: 'Not ready yet',
    }
    return content;
  } catch (error) { console.log('my_module_favourite_page - ' + error); }
}


/* Device ready */

document.addEventListener("deviceready", my_module_device_ready,false);
window.addEventListener("orientationchange", my_module_orientationChange, true);

function my_module_device_ready() {
  default_sort_order = variable_get('my_module_default_sort_order', 1);  
  user_language = variable_get('my_module_user_language', 3);  
  show_portrait_landline = variable_get('my_module_show_portrait_landline', 1);
  show_portrait_mobile = variable_get('my_module_show_portrait_mobile', 1);
  show_portrait_sms = variable_get('my_module_show_portrait_sms', 1);
  show_portrait_landline2 = variable_get('my_module_show_portrait_landline2', 0);
  show_portrait_mobile2 = variable_get('my_module_show_portrait_mobile2', 0);
  show_landscape_landline = variable_get('my_module_show_landscape_landline', 1);
  show_landscape_mobile = variable_get('my_module_show_landscape_mobile', 1);
  show_landscape_sms = variable_get('my_module_show_landscape_sms', 1);
  show_landscape_landline2 = variable_get('my_module_show_landscape_landline2', 1);
  show_landscape_mobile2 = variable_get('my_module_show_landscape_mobile2', 1);
}

function my_module_orientationChange() {
  drupalgap_remove_pages_from_dom();
}

/* Misc functions */

function my_module_check_orientation() {
  if (window.orientation == 0)
      current_orientation = "portrait";
  else if (window.orientation == 90)
      current_orientation = "landscape";
  else if (window.orientation == -90)
      current_orientation = "landscape";
  else if (window.orientation == 180)
      current_orientation = "portrait";
}

function title_to_link(text) {
  return text.replace(/ /g, "_");
}

function title_to_term(text) {
  var term = text.toLowerCase();
  term = term.replace(/ /g, "-");
  return term;
}

function link_to_title(text) {
//  var title = text.toLowerCase();
  return text.replace(/_/g, " ");
//  return term;
}

function link_to_term(text) {
  var term = text.toLowerCase();
  term = term.replace(/_/g, "-");
  return term;
}


function draw_button(text, pic, height) {
  return  '<div style="width: 100%; height: '+height+'px; position: relative">'+
          '  <img style="vertical-align: middle; max-height: '+height+'" src="'+pic+'">'+
          '</div>'+
          '<div style="text-align: center;">'+text+'</div>';

}

function button_image_link(text, pic, link) {
//  return bl(theme('image', {path: pic)+'<br>'+text, link, {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }});
  return bl(draw_button(text, pic, 80), link, {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }});
}

function grid_func(a, b) {
  var c = a % b;
  switch (c) {
    case 0: return 'a';
    case 1: return 'b';
    case 2: return 'c';
    case 3: return 'd';
    case 4: return 'e';
  }
}


/* Language */

function checkLocale() {
  navigator.globalization.getLocaleName(
    function (locale) {
      var loc = locale.value.toLowerCase();
      switch (loc) {
        case 'tr':
        case 'tr-tr':
//        case 'tr-TR':
//          drupalgap.settings.loader.loading.text = 'Lütfen bekleyin...';
          if (Drupal.settings.language_default !== 'tr') {
            Drupal.settings.language_default = 'tr';
            return;
          }
          break;
        case 'en':
        case 'en-us':
//          drupalgap.settings.loader.loading.text = 'Please wait...';
          if (Drupal.settings.language_default !== 'en') {
            Drupal.settings.language_default = 'en';
          }
          break;
        default:
//          drupalgap.settings.loader.loading.text = 'Please wait...';
          if (Drupal.settings.language_default !== 'en') {
            Drupal.settings.language_default = 'en';
          }
          break;
      }
    },
    function () {alert('Error getting locale\n');}
  );
}    

function change_language() {
  switch (user_language) {
    case '1':
      checkLocale();
      break;
    case '2':
//      drupalgap.settings.loader.loading.text = 'Lütfen bekleyin...';
      if (Drupal.settings.language_default != 'tr') {
        Drupal.settings.language_default = 'tr';
//        drupalgap_remove_all_pages_from_dom();
      }
      break;
    case '3':
//      drupalgap.settings.loader.loading.text = 'Please wait...';
      if (Drupal.settings.language_default != 'en') {
        Drupal.settings.language_default = 'en';
      }
      break;
  }
}

function my_module_locale() {
  return ['tr'];
}

/* End */





























/*

document.addEventListener('pause', backgroundApp, false);
document.addEventListener('resume', resumeApp, false);

function resumeApp() {
  if (user_alarm_konum == 0)
		watchID = navigator.geolocation.watchPosition(geolocation_success, geolocation_error, watchOptions);
}

function backgroundApp() {
  if (user_alarm_konum == 0)
		navigator.geolocation.clearWatch(watchID);
}
*/



function my_module_offline_page() {
  try {
    var content = {
      'message': {
        'markup': '<h2>Bağlantı Hatası</h2>' +
          "<p>"+t("Oops! We couldn't connect to")+":</p>" +
          '<p>' + Drupal.settings.site_path + '</p>'
      },
      'try_again': {
        'theme': 'button',
        'text': t('Try Again'),
        'attributes': {
          'onclick': 'javascript:offline_try_again();'
        }
      },
      'footer': {
        'markup': "<p>"+t("Check your device's network settings and try again.")+"</p>"
      }
    };
    return content;
  }
  catch (error) { console.log('my_module_offline_page - ' + error); }
}
