var current_latitude = null;
var current_longitude = null;
var current_orientation = "";

var terms_firma;
var terms_kategori;
var terms_sektor;
var opt_firma = [];
var opt_sektor = [];
var opt_kategori = [];

var user_language = 1;
var user_alarm_konum = 0;
var user_alarm_yeni = 0;
var user_alarm_mesafe = 1;

var _my_module_user_latitude = null;
var _my_module_user_longitude = null;
var _my_module_map_id = 0;
var html = '';
var my_module_image_height = 30;

var watchOptions = { timeout: 30000 };
var watchID = navigator.geolocation.watchPosition(geolocation_success, geolocation_error, watchOptions);

document.addEventListener('pause', backgroundApp, false);
document.addEventListener('resume', resumeApp, false);

function resumeApp() {
  if (user_alarm_konum == 0)
		watchID = navigator.geolocation.watchPosition(geolocation_success, geolocation_error, watchOptions);
}

function backgroundApp() {
  if (user_alarm_konum == 0)
		navigator.geolocation.clearWatch(watchID);
}

function checkLocale() {
  navigator.globalization.getLocaleName(
    function (locale) {
      var loc = locale.value.toLowerCase();
      switch (loc) {
        case 'tr':
        case 'tr-tr':
//        case 'tr-TR':
//          drupalgap.settings.loader.loading.text = 'Lütfen bekleyin...';
          if (Drupal.settings.language_default !== 'tr') {
            Drupal.settings.language_default = 'tr';
            return;
          }
          break;
        case 'en':
        case 'en-us':
//          drupalgap.settings.loader.loading.text = 'Please wait...';
          if (Drupal.settings.language_default !== 'en') {
            Drupal.settings.language_default = 'en';
          }
          break;
        default:
//          drupalgap.settings.loader.loading.text = 'Please wait...';
          if (Drupal.settings.language_default !== 'en') {
            Drupal.settings.language_default = 'en';
          }
          break;
      }
    },
    function () {alert('Error getting locale\n');}
  );
}    

function change_language() {
  switch (user_language) {
    case '1':
      checkLocale();
      break;
    case '2':
//      drupalgap.settings.loader.loading.text = 'Lütfen bekleyin...';
      if (Drupal.settings.language_default != 'tr') {
        Drupal.settings.language_default = 'tr';
//        drupalgap_remove_all_pages_from_dom();
      }
      break;
    case '3':
//      drupalgap.settings.loader.loading.text = 'Please wait...';
      if (Drupal.settings.language_default != 'en') {
        Drupal.settings.language_default = 'en';
      }
      break;
  }
}

function my_module_locale() {
  return ['tr'];
}

function my_module_startup_process() {
  user_language = variable_get('my_module_user_language', 1);
  change_language();
  my_module_check_orientation();

  if (empty(terms_firma))
    read_all_terms();
  if (Drupal.user.uid > 0) {
    my_notification_deviceready();
    user_load(Drupal.user.uid, {
      success: function(account) {
        user_alarm_yeni = variable_get('my_module_alarm_yeni', 0);
        user_alarm_konum = variable_get('my_module_alarm_konum', 0);
        user_alarm_mesafe = variable_get('my_module_alarm_mesafe', 1);
        if (account['field_user_alarm_yeni']['und'][0]['value'])
          user_alarm_yeni = account['field_user_alarm_yeni']['und'][0]['value'];
        if (account['field_user_alarm_konum']['und'][0]['value'])
          user_alarm_konum = account['field_user_alarm_konum']['und'][0]['value'];
        if (account['field_user_alarm_mesafe']['und'][0]['value'])
          user_alarm_mesafe = account['field_user_alarm_mesafe']['und'][0]['value'];
        variable_set('my_module_alarm_yeni', user_alarm_yeni);
        variable_set('my_module_alarm_konum', user_alarm_konum);
        variable_set('my_module_alarm_mesafe', user_alarm_mesafe);
      }
    });
  } else {
    user_alarm_yeni = variable_get('my_module_alarm_yeni', 0);
    user_alarm_konum = variable_get('my_module_alarm_konum', 0);
    user_alarm_mesafe = variable_get('my_module_alarm_mesafe', 1);
  }
}

function my_module_menu() {	
  var items = {};

  items['offline'] = {
    title: t('Offline'),
    page_callback: 'my_module_offline_page'
  };
  items['home'] = {
    title: 'Fırsatmatik',
    page_callback: 'my_module_home_page',
		options: { reloadPage: true }
  };

  items['yakin_firsatlar'] = {
    title: t2('Deals near me'),
    page_callback: 'my_module_yakin_firsatlar_page',
		options: { reloadPage: true }
  };

  items['firsatlar'] = {
    title: t2('All deals'),
    page_callback: 'my_module_firsatlar_page',
		options: { reloadPage: true }
  };

  items['firmalar'] = {
    title: t2('Companies'),
    page_callback: 'my_module_firmalar_page',
		options: { reloadPage: true }
  };

  items['firsat/%'] = {
    title: t2('Deal'),
    page_callback: 'my_module_firsat_page',
    page_arguments: [1],
		options: { reloadPage: true }
  };

  items['harita'] = {
    title: t2('Map'),
    page_callback: 'my_module_map',
		pageshow: 'my_module_map_pageshow',
		options: { reloadPage: true }
  };

  items['kategori/%'] = {
    title: 'Fırsatmatik',
    page_callback: 'my_module_kategori_page',
    page_arguments: [1],
  };

  items['picture'] = {
    title: 'Resim',
    page_callback: 'my_module_picture_page',
  };

  items['firsat_ekle'] = {
    title: t2('Add deal'),
		page_callback: 'drupalgap_get_form',
		page_arguments: ['my_module_firsat_ekle'],
		options: { reloadPage: true }
  };

	items['settings'] = {
		title: t2('My settings'),
		page_callback: 'drupalgap_get_form',
		page_arguments: ['my_module_settings_form'],
		options: { reloadPage: true }
	};

  items['logout'] = {
    title: 'Logout',
    page_callback: 'my_module_logout',
  };
  items['about'] = {
    title: t2('About'),
    page_callback: 'my_module_about_page',
  };

  items['exit'] = {
    title: t2('Exit'),
    page_callback: 'my_module_exit_page',
  };

  return items;
}

function read_all_terms() {
  var query = {
    fields:['vid'],
    parameters:{
      'name': 'firma'
    }
  };
  taxonomy_vocabulary_index(query, {
      success:function(vocabularies){
        if (vocabularies.length == 0) { return; }
        var vocabulary = vocabularies[0];
        var vid = vocabulary.vid;
        query = {
          parameters: {
            vid: vid
          }
        };
        taxonomy_term_index(query, {
            success: function(terms) {
              terms.reverse();
              terms_firma = terms;
              if (terms.length == 0) { return; }
              opt_firma = [];
              opt_firma[0] = t2('Please select');
              opt_firma[1] = t2('None'); 
              for (var i in terms_firma)
                opt_firma[Number(i)+2] = terms_firma[i].name;
            }
        });
      }
  });
  var query2 = {
    fields:['vid'],
    parameters:{
      'name': 'sektor'
    }
  };
  vid = taxonomy_vocabulary_index(query2, {
      success: function(vocabularies){
        if (vocabularies.length == 0) { return; }
        var vocabulary = vocabularies[0];
        var vid = vocabulary.vid;
        query = {
          parameters: {
            vid: vid
          }
        };
        taxonomy_term_index(query, {
            success: function(terms) {
              terms.reverse();
              terms_sektor = terms;
              if (terms.length == 0) { return; }
              opt_sektor = [];
              opt_sektor[0] = t2('Please select'); 
              opt_sektor[1] = t2('None');
              for (var i in terms_sektor)
                opt_sektor[Number(i)+2] = terms_sektor[i].name;
            }
        });
      }
  });
  var query3 = {
    fields:['vid'],
    parameters:{
      'name': 'kategori'
    }
  };
  vid = taxonomy_vocabulary_index(query3, {
      success: function(vocabularies){
        if (vocabularies.length == 0) { return; }
        var vocabulary = vocabularies[0];
        var vid = vocabulary.vid;
        query = {
          parameters: {
            vid: vid
          }
        };
        taxonomy_term_index(query, {
            success: function(terms) {
              terms.reverse();
              terms_kategori = terms;
              if (terms.length == 0) { return; }
              opt_kategori = [];
              opt_kategori[0] = t2('Please select');
              opt_kategori[1] = t2('None'); 
              for (var i in terms_kategori)
                opt_kategori[Number(i)+2] = terms_kategori[i].name;
            }
        });
      }
  });
}


function toRad(value) {
	  var RADIANT_CONSTANT = 0.0174532925199433;
	  return (value * RADIANT_CONSTANT);
}

function calculateDistance(starting_latitude, starting_longitude, ending_latitude, ending_longitude) {
	var KM_RATIO = 6371;
	try {      
		var dLat = toRad(ending_latitude - starting_latitude);
		var dLon = toRad(ending_longitude - starting_longitude);
		var lat1Rad = toRad(starting_latitude);
		var lat2Rad = toRad(ending_latitude);
		
		var a = Math.sin(dLat / 2) * Math.sin(dLat / 2) +
						Math.sin(dLon / 2) * Math.sin(dLon / 2) * Math.cos(lat1Rad) * Math.cos(lat2Rad);
		var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
		var d = KM_RATIO * c;
		return d;
	} catch(e) {
		return -1;
	}
}

function my_module_save_location() {
// alert('1');
//  if (Drupal.user.uid > 0) {
// alert('2');
    user_load(Drupal.user.uid, {
      success: function(account) {
        account.field_user_konum = {
          und:[
            {
              geom: {
                lat: current_latitude,
                lon: current_longitude,
              }
            }
          ]
        };
        user_update(account, {
          success: function(result) {
//            alert('konum güncellendi');
          },
          error: function(error) {
            alert('error: '+ error);
          }
        });
      }
    });
//  }
}

function geolocation_success(position) {
  if (calculateDistance(current_latitude, current_longitude, position.coords.latitude, position.coords.longitude)*1000 > 2) {
    current_latitude = position.coords.latitude;
    current_longitude = position.coords.longitude;
    if (user_alarm_konum == 1) {
      if (Drupal.user.uid > 0) {
        user_load(Drupal.user.uid, {
          success: function(account) {
            account.field_user_konum = {
              und:[
                {
                  geom: {
                    lat: current_latitude,
                    lon: current_longitude,
                  }
                }
              ]
            };
            user_update(account, {
              success: function(result) {
//                alert('succ: '+ result);
              },
              error: function(error) {
                alert('error: '+ error);
              }
            });
          }
        });
      }
    }
  }
}

function geolocation_error(error) {
//	alert('code: '    + error.code    + '\n' +
//        'message: ' + error.message + '\n');
}

function human_readable_dist(dist) {
//		return Math.round(dist*1000)+' m';
	if (dist < 1)
		return Math.round(dist*1000)+' m';
	else
		return Math.round(dist)+' km';
}


function my_module_firsat_page(nid) {
  try {
		var content = {};
		content['firsat'] = {
			theme: 'view',
      pager_pos: 'bottom',
			format: 'image',
			path: 'mobile/firsat/'+nid,
			row_callback: 'my_module_firsat_list_row',
			empty_callback: 'my_module_firsat_list_empty',
			attributes: {
				id: 'my_firsat_'.nid
			}
		};
		return content;
  }
  catch (error) { 
		alert('my_module_firsat_page - ' + error);
		console.log('my_module_firsat_page - ' + error); }
}

function my_module_firsat_list_row(view, row) {
  try {
    window.analytics.trackView('Fırsat detayı: '+row.title);

    my_module_check_orientation();
    var grid = 3;
    var grid1 = 'b';
    if (current_orientation == 'portrait') {
      grid = 2;
      grid1 = 'a';
    }
    var b = '';
    var f = '';
    var html = '';

		html = '<h2 style="text-align: center;">'+row.title+'</h2>';

    if ((row.firma_logo.src) || (row.kategori_logo.src) || (row.sektor_logo.src)) {
      html += '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">';
      if (row.firma_logo.src)
        html += '  <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+row.firma_logo.src+'>';
      if (row.kategori_logo.src)
        html += '  <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+row.kategori_logo.src+'>';
      if (row.sektor_logo.src)
        html += '  <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+row.sektor_logo.src+'>';
      html += '</div><br>';
    }
    
		if (row.body)
			html += '<strong>'+t2('Detail')+':</strong> '+row.body+'<br><br>';
		if (row.picture_full.src) 
			html += '<div style="text-align: center;"><img src=\''+row.picture.src+'\'></div>';

    html += '<div class="ui-grid-'+grid1+'">';

    var no = 0;
		if (row.konum_bazli == 'Evet') {
			_my_module_user_latitude = row.latitude;
			_my_module_user_longitude = row.longitude;

      f = drupalgap_get_path('module', 'my_module') + '/map.png';
      b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
          ' <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src="'+f+'">'+
          '</div>';
      b += '<div style="text-align: center;">'+t2('Show on map')+'</div>';
      html += '<div class="ui-block-'+grid_func(no, grid)+'">'+
              bl(b, 'harita', { reloadPage: true, attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }})+
              '</div>';
      no++;
    }
    f = drupalgap_get_path('module', 'my_module') + '/share.png';
    b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
        ' <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src="'+f+'">'+
        '</div>';
    b += '<div style="text-align: center;">'+t2('Share')+'</div>';
    html += '<div class="ui-block-'+grid_func(no, grid)+'">'+
            '<a onTouchEnd="window.plugins.deviceFeedback.acoustic()" data-role="button" href="javascript:window.plugins.socialsharing.share(\''+t2('I think you will love this deal: ')+'\', null, null, \'http://www.firsatmatik.com'+row.link+'\')">'+b+'</a>'+
            '</div>';
    no++;
    
    if (row.ext_link) {
      f = drupalgap_get_path('module', 'my_module') + '/link.png';
      b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
          '  <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src="'+f+'">'+
          '</div>';
      b += '<div style="text-align: center;">'+t2('Link')+'</div>';

      html += '<div class="ui-block-'+grid_func(no, grid)+'">'+
                bl(b, null, {
                  attributes: {
                    onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                    onClick: "window.open('"+row.ext_link+"', '_system', 'location=yes')"
                  }
                })+
              '</div>';
    }
    no = 0;
    if ((row.firma) || (row.kategori) || (row.sektor))
      html += '</div>'+
            '<h3 style="text-align: left;">'+t2('Other deals you might be interested in:')+'</h3>'+
            '<div class="ui-grid-'+grid1+'">';
            
    if (row.firma) {
      b = '';
      if (row.firma_logo.src)
        b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
            ' <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+row.firma_logo.src+'>'+
            '</div>';
      b += '<div style="text-align: center;">'+row.firma+'</div>';
      html += '<div class="ui-block-'+grid_func(no, grid)+'">'+
              bl(b, 'kategori/'+row.firma_tid, {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }})+
              '</div>';
      no++;
    }
		if (row.kategori) {
      b = '';
      if (row.kategori_logo.src)
        b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
            ' <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+row.kategori_logo.src+'>'+
            '</div>';
      b += '<div style="text-align: center;">'+row.kategori+'</div>';
      html += '<div class="ui-block-'+grid_func(no, grid)+'">'+
              bl(b, 'kategori/'+row.kategori_tid, {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }})+
              '</div>';
      no++;
    }
		if (row.sektor) {
      b = '';
      if (row.sektor_logo.src)
        b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
            ' <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+row.sektor_logo.src+'>'+
            '</div>';
      b += '<div style="text-align: center;">'+row.sektor+'</div>';
      html += '<div class="ui-block-'+grid_func(no, grid)+'">'+
              bl(b, 'kategori/'+row.sektor_tid, {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }})+
              '</div>';
      no++;
    }
    html += '</div>';
/*
		if (row.author_uid == Drupal.user.uid)
			html += bl('Güncelle', 'node/'+row.nid+'/edit');
*/
		return html;
  }
  catch (error) { 
		alert('my_module_firsat_list_row - ' + error);
		console.log('my_module_firsat_list_row - ' + error); }
}

function my_module_firsat_list_empty(view) {
  try {
    return '<p>'+t2('No deals were found.')+'</p>';
  }
  catch (error) { 
		alert('my_module_firsat_list_empty - ' + error);
		console.log('my_module_firsat_list_empty - ' + error); }
}


/**
 * The map page callback.
 */
function my_module_map() {
  try {
		_my_module_map_id++;

		var height = window.innerHeight - 80;
		var content = {};
    var map_attributes = {
      id: 'my_module_map_'+_my_module_map_id,
      style: 'width: 100%; height: '+height+'px;'
    };
    content['map'] = {
      markup: '<div ' + drupalgap_attributes(map_attributes) + '></div>'
    };
    return content;
  }
  catch (error) { 
		alert('my_module_map - ' + error);
		console.log('my_module_map - ' + error); }
}

/**
 * The map pageshow callback.
 */
function my_module_map_pageshow() {
  try {
		var _my_module_map = null;
		var myLatlng = new google.maps.LatLng(
			_my_module_user_latitude,
			_my_module_user_longitude
			);      
		// Set the map's options.
		var mapOptions = {
			center: myLatlng,
			zoom: 15,
			mapTypeControl: true,
			mapTypeControlOptions: {
				style: google.maps.MapTypeControlStyle.DROPDOWN_MENU
			},
			zoomControl: true,
			zoomControlOptions: {
				style: google.maps.ZoomControlStyle.SMALL
			}
		};        
		// Initialize the map, and set a timeout to resize it properly.
		_my_module_map = new google.maps.Map(
			document.getElementById("my_module_map_"+_my_module_map_id),
			mapOptions
		);
		setTimeout(function() {
				google.maps.event.trigger(_my_module_map, 'resize');
				_my_module_map.setCenter(myLatlng);
		}, 500);        
		// Add a marker for the user's current position.
		var marker = new google.maps.Marker({
				position: myLatlng,
				map: _my_module_map,
				icon: 'http://maps.google.com/mapfiles/ms/icons/blue-dot.png'
		});        
  }
  catch (error) { 
		alert('my_module_map_pageshow - ' + error);
		console.log('my_module_map_pageshow - ' + error); }
}

function my_module_yakin_firsatlar_page() {
  try {
    window.analytics.trackView('Yakın fırsatlar');
    my_module_check_orientation();
    if (current_latitude == null) {
      alert('Konum bilgisi hazır değil');
      drupalgap_goto('home');
    }
		if (Drupal.user.uid > 0) {
      my_module_save_location();

      var content = {};
      content['yakin_firsatlar'] = {
        theme: 'view',
        pager_pos: 'bottom',
        format: 'unformatted_list',
        path: 'mobile/yakin-firsatlar',
        row_callback: 'my_module_yakin_firsatlar_list_row',
        empty_callback: 'my_module_yakin_firsatlar_list_empty',
        attributes: {
          id: 'my_yakin_firsatlar_list_view'
        }
      };
      return content;    

/*
			user_load(Drupal.user.uid, {
				success:function(account) {
          var dist = 1000 * calculateDistance(account['field_user_konum']['und'][0]['lat'], account['field_user_konum']['und'][0]['lon'], current_latitude, current_longitude);
          if (dist > 0) {
            account.field_user_konum = {
              und:[
                {
                  geom: {
                    lat: current_latitude,
                    lon: current_longitude,
                  }
                }
              ]
            };
            user_update(account, {
              success: function(result) {
*/
/*
              },
              error: function(error) {
                alert('error: '+ error);
              }
            });
          } 
				}
			});
*/
		} else {
      var content = {};
      content['yakin_firsatlar'] = {
        theme: 'view',
        pager_pos: 'bottom',
        format: 'unformatted_list',
        path: 'mobile/yakin-firsatlar-unreg/'+current_latitude+','+current_longitude,
        row_callback: 'my_module_yakin_firsatlar_list_row',
        empty_callback: 'my_module_yakin_firsatlar_list_empty',
        attributes: {
          id: 'my_yakin_firsatlar_list_view'
        }
      };
   		return content;    
    }
/*
    var content = {};
    content['yakin_firsatlar'] = {
      theme: 'view',
      pager_pos: 'bottom',
      format: 'unformatted_list',
      path: 'mobile/yakin-firsatlar',
      row_callback: 'my_module_yakin_firsatlar_list_row',
      empty_callback: 'my_module_yakin_firsatlar_list_empty',
      attributes: {
        id: 'my_yakin_firsatlar_list_view'
      }
    };
    return content;
*/
	}
  catch (error) { console.log('my_module_yakin_firsatlar_page - ' + error); }
}

function my_module_yakin_firsatlar_list_row(view, row) {
  try {
		if (current_latitude === null)
			var dist = '';
		else 
			var dist = human_readable_dist(row.proximity);

    var last = false;
    if (view.page * view.limit + row._position == view.count - 1) 
      last = true;
    else if (row._position == view.limit - 1)
      last = true;

    var picture = '';
    if (row.logo.src) picture = row.logo.src;
    else if (row.logo_sektor.src) picture = row.logo_sektor.src;
    else if (row.logo_kategori.src) picture = row.logo_kategori.src;
    else picture = drupalgap_get_path('module', 'my_module') + '/question.png';

    var grid = 'a';
    var col = 2;
    if (current_orientation == 'landscape') {
      grid = 'b';
      col = 3;
    }    
    if (row._position == 0)
      html = '<div class="ui-grid-'+grid+'" ui-responsive>';
  
    html += '  <div class="ui-block-'+grid_func(row._position, col)+'">';
    var b = '';
    b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
        ' <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+picture+'>'+
        '</div>';
    b += '<div style="text-align: center;">'+row.title+'</div>'+
         '<div style="text-align: right;">'+dist+'</div>';
    html += bl(b, 'firsat/' + row.nid, {attributes: { onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }});
    html += '</div>';
    
    if (last) {
      html += '</div>';
      return html;
    } else
      return '';
  }
  catch (error) { console.log('my_module_yakin_firsatlar_list_row - ' + error); }
}

function my_module_yakin_firsatlar_list_empty(view) {
  try {
    return '<p>'+t2('No deals were found.')+'</p>';
  }
  catch (error) { console.log('my_module_firsatlar_list_empty - ' + error); }
}


function my_module_firsatlar_page() {
  try {
    window.analytics.trackView('Tüm fırsatlar');
    my_module_check_orientation();
		var content = {};

    if (Drupal.user.uid == 0)
      content['firsatlar'] = {
        theme: 'view',
        pager_pos: 'bottom',
        format: 'unformatted_list',
  			path: 'mobile/firsatlar-unreg',
        row_callback: 'my_module_firsatlar_list_row',
        empty_callback: 'my_module_firsatlar_list_empty',
        attributes: {
          id: 'my_firsatlar_list_view'
        }
      };
    else
      content['firsatlar'] = {
        theme: 'view',
        pager_pos: 'bottom',
        format: 'unformatted_list',
        path: 'mobile/firsatlar',
        row_callback: 'my_module_firsatlar_list_row',
        empty_callback: 'my_module_firsatlar_list_empty',
        attributes: {
          id: 'my_firsatlar_list_view'
        }
      };
		return content;
	}
  catch (error) { console.log('my_module_firsatlar_page - ' + error); }
}

function my_module_firsatlar_list_row(view, row) {
  try { 
    var last = false;
    if (view.page * view.limit + row._position == view.count - 1) 
      last = true;
    else if (row._position == view.limit - 1) 
      last = true;

		if ((Drupal.user.uid == 0) || (row.konum_bazli == 'Hayır') || (current_latitude == null))
			var dist = '';
		else 
			var dist = human_readable_dist(row.proximity);

    var grid = 'a';
    var col = 2;
    if (current_orientation == 'landscape') {
      grid = 'b';
      col = 3;
    }    
    if (row._position == 0)
      html = '<div class="ui-grid-'+grid+'" ui-responsive>';
    html += '  <div class="ui-block-'+grid_func(row._position, col)+'">';

    var picture = '';
    if (row.logo.src) picture = row.logo.src;
    else if (row.logo_sektor.src) picture = row.logo_sektor.src;
    else if (row.logo_kategori.src) picture = row.logo_kategori.src;
    else picture = drupalgap_get_path('module', 'my_module') + '/question.png';

    var b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
        ' <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+picture+'>'+
        '</div>';
    b += '<div style="text-align: center;">'+row.title+'</div>';
    if (dist)
      b += '<div style="text-align: right;">'+dist+'</div>';
    else if (Drupal.user.uid != 0)
      b += '<br>';
    html += bl(b, 'firsat/' + row.nid, {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }});
    html += '</div>';
    if (last) {
      html += '</div>';
      return html;
    } else
      return '';
  }
  catch (error) { console.log('my_module_firsatlar_list_row - ' + error); }
}

function my_module_firsatlar_list_empty(view) {
  try {
    return '<p>'+t2('No deals were found.')+'</p>';
  }
  catch (error) { console.log('my_module_firsatlar_list_empty - ' + error); }
}


function my_module_kategori_page(tid) {
  try {
    window.analytics.trackView('Kategori: '+tid);
    my_module_check_orientation();
		var content = {};
    if (Drupal.user.uid == 0)
      content['kategori'] = {
        theme: 'view',
        pager_pos: 'bottom',
        format: 'unformatted_list',
  			path: 'mobile/kategori-unreg/'+tid,
        row_callback: 'my_module_kategori_list_row',
        empty_callback: 'my_module_kategori_list_empty',
        attributes: {
          id: 'my_kategori_list_view_'+tid
        }
      };
    else
		content['kategori'] = {
			theme: 'view',
      pager_pos: 'bottom',
			format: 'unformatted_list',
			path: 'mobile/kategori/'+tid,
			row_callback: 'my_module_kategori_list_row',
			empty_callback: 'my_module_kategori_list_empty',
			attributes: {
				id: 'my_kategori_list_view_'+tid
			}
		};    
		return content;
	}
  catch (error) { console.log('my_module_kategori_page - ' + error); }
}

function my_module_kategori_list_row(view, row) {
  try {
		if (current_latitude === null)
			var dist = '';
		else 
			var dist = human_readable_dist(row.proximity);
		if ((Drupal.user.uid == 0) || (row.konum_bazli == 'Hayır'))
			dist = '';

    var last = false;
    if (view.page * view.limit + row._position == view.count - 1) 
      last = true;
    else if (row._position == view.limit - 1) 
      last = true;

    var grid = 'a';
    var col = 2;
    if (current_orientation == 'landscape') {
      grid = 'b';
      col = 3;
    }    

    var picture = '';
    if (row.logo.src) picture = row.logo.src;
    else if (row.logo_sektor.src) picture = row.logo_sektor.src;
    else if (row.logo_kategori.src) picture = row.logo_kategori.src;
    else picture = drupalgap_get_path('module', 'my_module') + '/question.png';

    if (row._position == 0)
      html =  '<div data-role=header><h2>' + row.term_title + '</h2></div>'+
              '<div class="ui-grid-'+grid+'" ui-responsive>';
    html += '  <div class="ui-block-'+grid_func(row._position, col)+'">';

    var b = '';
    b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
        ' <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+picture+'>'+
        '</div>';
    b += '<div style="text-align: center;">'+row.title+'</div>';
    if (dist)
      b += '<div style="text-align: right;">'+dist+'</div>';
    else if (Drupal.user.uid != 0)
      b += '<br>';

    html += bl(b, 'firsat/' + row.nid, {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }});
    html += '</div>';
    if (last) {
      html += '</div>';
      return html;
    } else
      return '';
  }
  catch (error) { console.log('my_module_kategori_list_row - ' + error); }
}

function my_module_kategori_list_empty(view) {
  try {
    return '<p>'+t2('No deals were found.')+'</p>';
  }
  catch (error) { console.log('my_module_kategori_list_empty - ' + error); }
}


function my_module_firmalar_page() {
  try {
    window.analytics.trackView('Firmalar');
    my_module_check_orientation();
		var content = {};

    content['firmalar'] = {
      theme: 'view',
      pager_pos: 'bottom',
      format: 'unformatted_list',
      path: 'mobile/firmalar',
      row_callback: 'my_module_firmalar_list_row',
      empty_callback: 'my_module_firmalar_list_empty',
      attributes: {
        id: 'my_firmalar_list_view'
      }
    };
		return content;
	}
  catch (error) { console.log('my_module_firmalar_page - ' + error); }
}

function my_module_firmalar_list_row(view, row) {
  try {   
    var last = false;
    if (view.page * view.limit + row._position == view.count - 1) 
      last = true;
    else if (row._position == view.limit - 1) 
      last = true;

    var grid = 'a';
    var col = 2;
    if (current_orientation == 'landscape') {
      grid = 'b';
      col = 3;
    }    
    if (row._position == 0)
      html = '<div class="ui-grid-'+grid+'" ui-responsive>';
    html += '  <div class="ui-block-'+grid_func(row._position, col)+'">';

    var b = '';
    if (row.logo.src)
      b = '<div style="width: 100%; height: '+my_module_image_height+'px; position: relative">'+
          ' <img style="vertical-align: middle; max-height: '+my_module_image_height+'" src='+row.logo.src+'>'+
          '</div>';
    b += '<div style="text-align: center;">'+row.title+'</div>';
    html += bl(b, 'kategori/' + row.tid, {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }});
    html += '</div>';
//    if (row._position == view.count - 1) {
    if (last) {
      html += '</div>';
      return html;
    } else
      return '';
  }
  catch (error) { console.log('my_module_firmalar_list_row - ' + error); }
}

function my_module_firmalar_list_empty(view) {
  try {
    return '<p>'+t2('No compainies were found.')+'</p>';
  }
  catch (error) { console.log('my_module_firmalar_list_empty - ' + error); }
}


function my_module_picture_page() {
//	drupalgap_alert(global_picture);
  window.location(global_picture,'_blank','location=no,enableViewportScale=true');
}

function grid_func(a, b) {
  var c = a % b;
  switch (c) {
    case 0: return 'a';
    case 1: return 'b';
    case 2: return 'c';
    case 3: return 'd';
  }
}

function my_module_home_page() {
  try {
    my_module_check_orientation();
    var content = {};
    if (current_orientation == 'portrait') {
      var grid = 2;
      var grid1 = 'a';
    } else {
      var grid = 3;
      var grid1 = 'b';
    }
      
    content['button1'] = {
      theme: 'markup',
      markup: '<div class="ui-grid-'+grid1+'">'+
              '<div class="ui-block-'+grid_func(0, grid)+'">'+
              bl(theme('image', {path: drupalgap_get_path('module', 'my_module') + '/near-me.png'})+'<br>'+t2('Deals near me'), 'yakin_firsatlar', {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }})+
              '</div>',
    }
    content['button2'] = {
      theme: 'markup',
      markup: '<div class="ui-block-'+grid_func(1, grid)+'">'+
              bl(theme('image', {path: drupalgap_get_path('module', 'my_module') + '/deals.png'})+'<br>'+t2('All deals'), 'firsatlar', {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }})+
              '</div>',
    }
    content['button3'] = {
      theme: 'markup',
      markup: '<div class="ui-block-'+grid_func(2, grid)+'">'+
              bl(theme('image', {path: drupalgap_get_path('module', 'my_module') + '/tag.png'})+'<br>'+t2('Companies'), 'firmalar', {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }})+
              '</div>',
    }
    content['button4'] = {
      theme: 'markup',
      markup: '<div class="ui-block-'+grid_func(3, grid)+'">'+
              bl(theme('image', {path: drupalgap_get_path('module', 'my_module') + '/new.png'})+'<br>'+t2('Add deal'), 'firsat_ekle', {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }})+
              '</div>',
    }
    content['button5'] = {
      theme: 'markup',
      markup: '<div class="ui-block-'+grid_func(4, grid)+'">'+
              bl(theme('image', {path: drupalgap_get_path('module', 'my_module') + '/info.png'})+'<br>'+t2('About'), 'about', {attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }})+
              '</div>',
    }

    content['button6'] = {
      theme: 'markup',
      markup: '<div class="ui-block-'+grid_func(5, grid)+'">'+
              bl(theme('image', {path: drupalgap_get_path('module', 'my_module') + '/settings.png'})+'<br>'+t2('My settings'), 'settings', { reloadPage: true, attributes: {onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }})+
              '</div>',
    }
    content['end'] = {
      theme: 'markup',
      markup: '</div>',
    }
    return content; 
  }  catch (error) { console.log('my_module_home_page - ' + error); }
}


function my_module_about_page() {
  try {
    window.analytics.trackView('About Page');

    var content = {};
    content['about_page'] = {
      markup: '<div style="text-align: center;">'+
							'  <img src=images/logo.png>'+
							'  <h3>Fırsatmatik 2.0.0</h3>'+
							'</div>'+
              t2('<strong>Fırsatmatik</strong> is a mobile application that you can share shopping deals with locations. You can read same deals at www.firsatmatik.com website.')+
              '<br><br>'+
              '<div class="ui-grid-a">'+
              '  <div class="ui-block-a">'+
              bl(t2('Share'), null, {
                attributes: {
                  onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                  onClick: "window.plugins.socialsharing.share('"+t2('I recommend you to use this mobile application:')+" ', null, null, 'https://play.google.com/store/apps/details?id=com.kteknoloji.firsat_matik')"
                }
              })+
              '  </div>'+
              '  <div class="ui-block-b">'+
              bl(t2('Rate us'), null, {
                attributes: {
                  onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                  onClick: "window.open('https://play.google.com/store/apps/details?id=com.kteknoloji.firsat_matik', '_system', 'location=yes')"
                }
              })+
              '  </div>'+
              '</div>'+
//              '<div class="ui-block-a">'+
              bl(t2('Visit website'), null, {
                attributes: {
                  onTouchEnd: "window.plugins.deviceFeedback.acoustic()",
                  onClick: "window.open('http://www.firsatmatik.com', '_system', 'location=yes')"
                }
              })
//              '</div>',
    };
    return content;
  }  catch (error) { console.log('my_module_about_page - ' + error); }
}

function my_module_exit_page() {
  try {
    navigator.app.exitApp();
  }  catch (error) { console.log('my_module_exit_page - ' + error); }
}


/**
 * Implements hook_block_info().
 */
function my_module_block_info() {
  try {
    var blocks = {};
    blocks['my_panel_block'] = {
      delta: 'my_panel_block',
      module: 'my_module'
    };
    blocks['my_panel_block_button'] = {
      delta: 'my_panel_block_button',
      module: 'my_module'
    };
    return blocks;
  }
  catch (error) { console.log('my_module_block_info - ' + error); }
}

/**
 * Implements hook_block_view().
 */
function my_module_block_view(delta, region) {
  try {
    var content = '';
    switch (delta) {

      // The slide menu (aka panel).
      case 'my_panel_block':
        var attrs = {
          id: drupalgap_panel_id(delta),
          'data-role': 'panel',
          'data-position': 'left', // left or right
          'data-display': 'overlay' // overlay, reveal or push
        };
        var items = [
          bl(t2('Homepage'), 'home', {
              reloadPage: true,
              attributes: {
                'data-icon': 'home',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t2('Deals near me'), 'yakin_firsatlar', {
              attributes: {
                'data-icon': 'location-arrow',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t2('All deals'), 'firsatlar', {
              attributes: {
                'data-icon': 'shopping-cart',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t2('Add deal'), 'firsat_ekle', {
              reloadPage: true,
              attributes: {
                'data-icon': 'plus',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t2('My settings'), 'settings', {
              reloadPage: true,
              attributes: {
                'data-icon': 'gear',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t2('Contact'), 'node/67', {
//          bl(t2('Contact'), 'content/bize-yazin', {
//          bl(t2('Contact'), 'contact', {
              reloadPage: true,
              attributes: {
                'data-icon': 'comment-o',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t2('Rate us'), null, {
              attributes: {
                'data-icon': 'star',
               	onclick: "window.open('market://details?id=com.kteknoloji.firsat_matik', '_system', 'location=yes')",
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t2('Visit website'), null, {
              attributes: {
                'data-icon': 'globe',
               	onclick: "window.open('http://www.firsatmatik.com', '_system', 'location=yes')",
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t2('About'), 'about', {
              attributes: {
                'data-icon': 'info-circle',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
          bl(t2('Exit'), 'exit', {
              attributes: {
                'data-icon': 'power',
                onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
              }
          }),
        ];
        content += '<div ' + drupalgap_attributes(attrs) + '>' +
          '<!-- panel content goes here -->' +
          theme('jqm_item_list', { items: items }) +
        '</div><!-- /panel -->';
        break;

      // The button to open the menu.
      case 'my_panel_block_button':
        content = bl('Open panel', '#' + drupalgap_panel_id('my_panel_block'), {
            attributes: {
              'data-icon': 'bars',
              'data-iconpos': 'notext',
              'class': 'ui-btn-left',
              onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
            }
        });
        break;
    }
    return content;
  }
  catch (error) { console.log('my_module_block_view - ' + error); }
}

/**
 * The map pageshow callback.
 */

function my_module_settings_form(form, form_state) {
  try {
    var user_not_logged_in = true;
		if (Drupal.user.uid > 0) user_not_logged_in = false;
/*
    user_alarm_yeni = variable_get('my_module_alarm_yeni', 0);
    user_alarm_konum = variable_get('my_module_alarm_konum', 0);
    user_alarm_mesafe = variable_get('my_module_alarm_mesafe', 1);
    if (user_alarm_yeni === '') user_alarm_yeni = 0;
    if (user_alarm_konum != 1) user_alarm_konum = 0;
    
		if (Drupal.user.uid > 0) {
      user_not_logged_in = false;
			user_load(Drupal.user.uid, {
				success: function(account) {
					user_alarm_yeni = account['field_user_alarm_yeni']['und'][0]['value'];
					user_alarm_konum = account['field_user_alarm_konum']['und'][0]['value'];
					user_alarm_mesafe = account['field_user_alarm_mesafe']['und'][0]['value'];
				}
			});
		}
*/
    form.elements['checkbox1'] = {
      title: t2('Notify new deals'),
      type: 'radios',
      disabled: user_not_logged_in,
      options: {
        0: t2('Never'),
        1: t2('All'),
        2: t2('Only close to me'),
      },
      default_value: user_alarm_yeni,
    };
    form.elements['range'] = {
      type: 'range',
      title: t2('Distance (km)'),
			description: t2('How far deals should be notified'),
      disabled: user_not_logged_in,
      attributes: {
        'min': '1',
        'max': '20',
        'value': user_alarm_mesafe,
        'data-theme': 'a',
      }
    };
    form.elements['checkbox2'] = {
      type: 'checkbox',
      disabled: user_not_logged_in,
      title: t2("Notify deals that I'm close to them"),
			description: t2('Warning: Battery usage may be increased'),
			default_value: user_alarm_konum,
    };
    form.elements['lang'] = {
      title: t2('Language'),
      type: 'select',
      options: {
        0: t2('Please select'),
        1: t2('System default'),
        2: t2('Turkish'),
        3: t2('English'),
      },
      required: false,
      default_value: user_language,
      attributes: { onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }
    };
    form.elements['submit'] = {
      type: 'submit',
      value: t2('Ok'),
      attributes: { onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }
    };

    if (user_not_logged_in) {
      form.prefix += '<p>'+t2('You need to register, if you want to get notification messages.')+'</p>';
      form.buttons['login_account'] = {
        title: t2('Login'),
        prefix: '<div class="ui-grid-a"><div class="ui-block-a">',
        suffix: '</div>',
        attributes: {
          onclick: "drupalgap_goto('user/login')",
          onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
        }
      };
      form.buttons['create_new_account'] = {
        title: t2('Register'),
        prefix: '<div class="ui-block-b">',
        suffix: '</div></div>',
        attributes: {
          onclick: "drupalgap_goto('user/register')",
          onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
        }
      };
    } else {
      form.buttons['my_account'] = {
        title: t2('My account'),
        attributes: {
          onclick: "drupalgap_goto('user')",
          onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
        }
      };
      form.buttons['logout'] = {
        title: t2('Logout'),
        attributes: {
          onclick: "drupalgap_goto('logout')",
          onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
        }
      };      
    }

    return form;
  }
  catch (error) { alert(error);console.log('my_module_custom_form - ' + error); }
}

function my_module_settings_form_submit(form, form_state) {
  try {
    if (user_language != form_state.values['lang']) {
      user_language = form_state.values['lang'];
      variable_set('my_module_user_language', user_language);
      change_language();
    }
		if (Drupal.user.uid > 0) {
      user_alarm_yeni = form_state.values['checkbox1'];
      user_alarm_konum = form_state.values['checkbox2'];
      user_alarm_mesafe = form_state.values['range'];
      if (user_alarm_yeni === '') user_alarm_yeni = 0;
      if (user_alarm_konum === '') user_alarm_konum = 0;
      if (user_alarm_mesafe === '') user_alarm_mesafe = 1;
      variable_set('my_module_alarm_yeni', user_alarm_yeni);
      variable_set('my_module_alarm_konum', user_alarm_konum);
      variable_set('my_module_alarm_mesafe', user_alarm_mesafe);
/*
      user_alarm_yeni = variable_get('my_module_alarm_yeni', 0);
      user_alarm_konum = variable_get('my_module_alarm_konum', 0);
      user_alarm_mesafe = variable_get('my_module_alarm_mesafe', 1);

      if (user_alarm_yeni === '') user_alarm_yeni = 0;
      if (user_alarm_konum != 1) user_alarm_konum = 0;
      if (user_alarm_mesafe == '') user_alarm_mesafe = 1;
*/
//alert(user_alarm_yeni+' '+user_alarm_konum+' '+user_alarm_mesafe);

      var lat = current_latitude;
      var lon = current_longitude;
			user_load(Drupal.user.uid, {
				success: function(account) {
          account.field_user_konum = {
            und:[
              {
                geom: {
                  lat: lat,
                  lon: lon,
                }
              }
            ]
          };
          account.field_user_alarm_yeni = {
            und:[
              {
                  value: user_alarm_yeni,
              }
            ]
          };
          account.field_user_alarm_konum = {
            und:[
              {
                  value: user_alarm_konum,
              }
            ]
          };
          account.field_user_alarm_mesafe = {
            und:[
              {
                  value: user_alarm_mesafe,
              }
            ]
          };
					user_update(account, {
						success: function(result) {
							alert(t2('Settings recorded'));
              drupalgap_goto('home');
						},
						error: function(xhr, status, message){
							alert('fail: '+message);
						}
					});	
				},
        error:function(xhr, status, message){
          alert('fail: '+message);
        }
			});
		} else {
      alert(t2('Settings recorded'));
      drupalgap_goto('home');
    }
  }
  catch (error) { console.log('my_module_custom_form_submit - ' + error); }
}

function my_module_logout() {
  try {
//    my_notification_delete_device_token();
    drupalgap_goto('user/logout');
  } catch (error) { 
    console.log('my_module_logout - ' + error); 
  }
}
/*
function my_module_my_account() {
  try {
    drupalgap_goto('user');
  } catch(error) {
    console.log('my_module_my_account - ' + error); 
  }
}
*/
function my_module_services_postprocess(options, result) {
  try {
    if ((options.service == 'system') && (options.resource == 'connect')) {
      my_module_startup_process();
    }

    if (options.service == 'user') {
      if (options.resource == 'login') {
//        alert(Drupal.user.uid);
        my_notification_deviceready();
        my_module_save_location();
      }
      if (options.resource == 'logout') {
        my_notification_delete_device_token();

        user_alarm_yeni = 0;
        user_alarm_konum = 0;
        user_alarm_mesafe = 1;
        variable_set('my_module_alarm_yeni', user_alarm_yeni);
        variable_set('my_module_alarm_konum', user_alarm_konum);
        variable_set('my_module_alarm_mesafe', user_alarm_mesafe);
      }
    }
  }
  catch (error) {
    console('push_notifications_services_postprocess - ' + error);
  }
}


function my_module_firsat_ekle(form, form_state) {
  try {
    var disabled_button = false;
    var disabled_text = '';
    if (Drupal.user.uid == 0) {
      disabled_button = true;
      disabled_text = t2('You need to register to add new deal');
    }
    var my_module_image_data = null;
    var location_disabled = false;
    var location_default = 1;
    var location_text = t2('Record location data while adding the deal?');
    if (current_latitude === null) {
      location_disabled = true;
      location_text = t2('Location data cannot be retrieved.');
      location_default = 0;
    }
    form.elements['title'] = {
      title: t2('Title'),
      type: 'textfield',
      required: true,
      default_value: ''
    };
    form.elements['title2'] = {
      title: t2('Detail'),
      type: 'textarea',
      default_value: ''
    };
    form.elements['title3'] = {
      title: t2('Location based'),
      type: 'checkbox',
      disabled: location_disabled,
      description: location_text,
      default_value: location_default,
    };
    form.elements['title4'] = {
      title: t2('Category'),
      type: 'select',
      options: opt_kategori,
      required: false,
      default_value: 1,
      attributes: { onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }
    };
    form.elements['title5'] = {
      title: t2('Sector'),
      type: 'select',
      required: false,
      options: opt_sektor,
      default_value: 1,
      attributes: { onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }
    };
    form.elements['title6'] = {
      title: t2('Company'),
      type: 'select',
      required: false,
      options: opt_firma,
      default_value: 1, 
      attributes: { onTouchEnd: "window.plugins.deviceFeedback.acoustic()" },
/*      attributes: {
          'data-native-menu': 'false',
          'multiple': 'multiple'
      }, 
      default_value: -1, */ 
    };
    form.buttons['photo1'] = {
      title: t2('Take photo'),
      attributes: {
        onclick: "my_module_camera_capturePhoto();",
        onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
      }
    };
    form.buttons['photo3'] = {
      title: t2('Select from gallery'),
      attributes: {
        onclick: "my_module_camera_getPhoto(pictureSource.PHOTOLIBRARY);",
        onTouchEnd: "window.plugins.deviceFeedback.acoustic()"
      }
    };
    form.elements['picture'] = {
        markup: '<img style="display:none;width:60px;height:60px;" id="smallImage" src="" />'+
                '<img style="display:none;" id="largeImage" src="" />',
    };
    form.elements['title7'] = {
      type: 'submit',
      disabled: disabled_button,
      description: disabled_text,
      value: t2('Ok'),
      attributes: { onTouchEnd: "window.plugins.deviceFeedback.acoustic()" }
    };
    return form;
  }
  catch (error) { 
//    alert(error);
    console.log('my_module_firsat_ekle - ' + error); 
  }
}

function my_module_firsat_ekle_submit(form, form_state) {
  try {
    var options;
    var picture_fid = '';

    if (my_module_image_data !== null) { 
      var lng = language_default();
      var d = new Date();
      var image_file_name = Drupal.user.uid + '_' + d.valueOf() + '.jpg';
      var file = {
        file: {
          file: my_module_image_data,
          filename: image_file_name,
          filepath: 'public://firsat/' + image_file_name
        }
      };
      if (!empty(Drupal.settings.file_private_path)) {
        file.file.filepath = 'private://' + image_file_name;
      }
      // Change the loader mode to saving, and save the file.
      drupalgap.loader = 'saving';
      processed_an_image = true;
      file_save(file, {
          async: false,
          success: function(result) {
              picture_fid = result.fid;
              my_module_add_firsat_content(form_state, picture_fid);
          }
      });
    } else 
      my_module_add_firsat_content(form_state, '');
  } catch (error) { console.log('my_module_custom_form_submit - ' + error); }
}

function my_module_add_firsat_content(form_state, picture_fid) {
  try {
    var title = form_state.values['title'];
    var body = form_state.values['title2'];
    var konum_bazli = form_state.values['title3'];
    var kategori = form_state.values['title4'];
    var sektor = form_state.values['title5'];
    var firma = form_state.values['title6'];
    
    var lat = current_latitude;
    var lon = current_longitude;
    var konum_bazli_str = 'Evet';
    if (konum_bazli == '0') {
      konum_bazli_str = 'Hayır';
      lat = '';
      lon = '';
    }

    var kategori_str = '';
    var sektor_str = '';
    var firma_str = '';
    if (kategori > 1)
      kategori_str =  terms_kategori[Number(kategori)-2].tid;
    if (sektor > 1)
      sektor_str = terms_sektor[Number(sektor)-2].tid;
    if (firma > 1)
      firma_str = terms_firma[Number(firma)-2].tid.toString();;
// alert('loc: '+lat+' '+lon);    
    var node = {
      type: "firsat",
      title: title,
      language: "und",
      body: {
        und:[
          {
            value: body,
            summary:'',
            format: 'full_html',
            safe_value: body,
            safe_summary:''
          }
        ]
      },
      field_firsat_loc_based: {
        und: 
          {
            value: konum_bazli_str,
          }
      },
    };
    if (lat !== null)
      node.field_firsat_konum = {
        und:[
          {
            geom: {
              lat: lat,
              lon: lon,
            }
          }
        ]
      };
    if (kategori_str)
      node.field_firsat_kategori = {
        und: 
          {
            value: kategori_str,
          }
      };
    if (sektor_str)
      node.field_firsat_sektor = {
        und:
          {
            value: sektor_str,
          }
      };
    if (firma_str)
      node.field_firsat_firma = {
        und: 
          {
            value: firma_str,
          }
      };
    if (picture_fid)
      node.field_firsat_fotograf = {
        und: [
          {
            fid: picture_fid,
          }
        ]
      };

    node_save(node, {
        success:function(result){
          alert(t2("Deal added successfully. Thank you for contribution."));
        },
        error: function(result){
          alert("error: " + result);
        },
    });

    drupalgap_goto('home');
  } catch (error) { console.log('my_moudle_add_firsat_content - ' + error); }
}

var pictureSource;   // picture source
var destinationType; // sets the format of returned value
var my_module_image_data = null;

// Wait for device API libraries to load
document.addEventListener("deviceready", my_module_onDeviceReady,false);
// window.addEventListener("orientationchange", my_module_orientationChange, true);

// device APIs are available
function my_module_onDeviceReady() {
  pictureSource = navigator.camera.PictureSourceType;
  destinationType = navigator.camera.DestinationType;
//  my_module_startup_process();
}

function my_module_check_orientation() {
  if (window.orientation == 0)
      current_orientation = "portrait";
  else if (window.orientation == 90)
      current_orientation = "landscape";
  else if (window.orientation == -90)
      current_orientation = "landscape";
  else if (window.orientation == 180)
      current_orientation = "portrait";
}

function my_module_camera_capturePhoto() {
  // Take picture using device camera and retrieve image as base64-encoded string
  navigator.camera.getPicture(my_module_camera_onPhotoDataSuccess, my_module_camera_onFail, { quality: 50, correctOrientation: true,
    destinationType: destinationType.DATA_URL });
}

// A button will call this function
function my_module_camera_getPhoto(source) {
  // Retrieve image file location from specified source
  navigator.camera.getPicture(my_module_camera_onPhotoDataSuccess, my_module_camera_onFail, { quality: 50,
    destinationType: destinationType.DATA_URL,
    sourceType: source });
}

function my_module_camera_onPhotoDataSuccess(imageData) {
  var largeImage = document.getElementById('largeImage');

  largeImage.style.display = 'block';
  largeImage.src = "data:image/jpeg;base64," + imageData;
  my_module_image_data = imageData;
}

// A button will call this function
function my_module_camera_capturePhotoEdit() {
  // Take picture using device camera, allow edit, and retrieve image as base64-encoded string
  navigator.camera.getPicture(my_module_camera_onPhotoDataSuccess, my_module_camera_onFail, { quality: 20, allowEdit: true,
    destinationType: destinationType.DATA_URL });
}

// Called if something bad happens.
function my_module_camera_onFail(message) {
//  alert('Failed because: ' + message);
}

function t2(str) {
  return t(str);
}

function my_module_offline_page() {
  try {
    var content = {
      'message': {
        'markup': '<h2>Bağlantı Hatası</h2>' +
          "<p>"+t2("Oops! We couldn't connect to")+":</p>" +
          '<p>' + Drupal.settings.site_path + '</p>'
      },
      'try_again': {
        'theme': 'button',
        'text': t2('Try Again'),
        'attributes': {
          'onclick': 'javascript:offline_try_again();'
        }
      },
      'footer': {
        'markup': "<p>"+t2("Check your device's network settings and try again.")+"</p>"
      }
    };
    return content;
  }
  catch (error) { console.log('my_module_offline_page - ' + error); }
}
