var pushNotification;
var GCM_SENDER_ID = '343333062976';
var registration_url = 'http://www.firsatmatik.com/drupalgap/push_notifications';
var get_token_url = "http://www.firsatmatik.com/services/session/token";

// document.addEventListener("deviceready", my_notification_deviceready, false);        

function my_notification_deviceready() {
  pushNotification = window.plugins.pushNotification;

  if ( device.platform.toLowerCase() == 'android') {
    pushNotification.register(
      my_notification_successHandler,
      my_notification_errorHandler,
      {
        "senderID": GCM_SENDER_ID,
        "ecb": "my_notification_onNotification"
      }
    );
  } else if ( device.platform == 'blackberry10'){
    pushNotification.register(
      my_notification_successHandler,
      my_notification_errorHandler,
      {
          invokeTargetId : "replace_with_invoke_target_id",
          appId: "replace_with_app_id",
          ppgUrl:"replace_with_ppg_url", //remove for BES pushes
          ecb: "pushNotificationHandler",
          simChangeCallback: replace_with_simChange_callback,
          pushTransportReadyCallback: replace_with_pushTransportReady_callback,
          launchApplicationOnPush: true
      }
    );
  } else {
    pushNotification.register(
      my_notification_tokenHandler,
      my_notification_errorHandler,
      {
          "badge":"true",
          "sound":"true",
          "alert":"true",
          "ecb":"onNotificationAPN"
      }
    );
  }
}
  
function my_notification_successHandler (result) {
}
  
function my_notification_errorHandler (error) {
  alert('error = ' + error);
}    
    
function my_notification_onNotification(e) {
  switch(e.event) {
    case 'registered':
      if ( e.regid.length > 0 ) {
          my_notification_register_device_token(e.regid)
          my_notification_registerInServer(e.regid);
          // Your GCM push server needs to know the regID before it can push to this device
          // here is where you might want to send it the regID for later use.
          console.log("regID = " + e.regid);
      }
      break;
    case 'message':
      // if this flag is set, this notification happened while we were in the foreground.
      // you might want to play a sound to get the user's attention, throw up a dialog, etc.
      if ( e.foreground ) {
          navigator.notification.beep(1);
          drupalgap_confirm(e.payload.message+' Bakmak istiyor musunuz?', {
            confirmCallback: function(button) {
              if (button == 1) my_notification_message_action(e);
            }
          });
      } else {  // otherwise we were launched because the user touched a notification in the notification tray.
          if ( e.coldstart ) {
            my_notification_message_action(e);
          } else {
            my_notification_message_action(e);
          }
      }
      break;
    case 'error':
      alert('error: '+e.msg);
      break;
    default:
      alert('unknown');
      break;
  }
}

function my_notification_message_action(e) {
// alert(e.payload.sound+' '+e.payload.soundname);
  switch (e.payload.sound) {
    case '1': // mesaj göster ve anasayfayı aç
      drupalgap_goto('home');
      break;
    case '2': // yeni fırsat eklendi
      drupalgap_goto('firsat/'+e.payload.soundname);
      break;
    case '3': // yakın fırsat alarmı
      drupalgap_goto('firsat/'+e.payload.soundname);
      break;
    case '4': // yakınınızda yeni fırsat eklendi
      drupalgap_goto('firsat/'+e.payload.soundname);
      break;
    case '5': // eklediğiniz fırsat onaylandı
      drupalgap_goto('firsat/'+e.payload.soundname);
      break;
  }
}

function my_notification_registerInServer(regid){
	$.ajax({
		url: get_token_url,
		type: "get",
		dataType: "text",
		error: function (jqXHR, textStatus, errorThrown) {
			console.log(textStatus);
		},
		success: function (token) {
			//Send session token, device id and device type to push_notifications drupal module
			$.ajax({
				url: registration_url,
				type: "post",
				dataType: "json",
				data: { 'token': regid , 'type': device.platform.toLowerCase() },
				beforeSend: function (request) {
					request.setRequestHeader("X-CSRF-Token", token);
				},
				error: function (jqXHR, textStatus, errorThrown) {
					console.log(errorThrown);
				},
				success: function (data) {
					console.log(data);
				}
			});
		}
	});
}

function my_notification_register_device_token(token) {
  if (localStorage.getItem('push_notifications_token') == token)
    my_notification_delete_device_token();
  localStorage.setItem("push_notifications_token", token);
}

function my_notification_delete_device_token() {
  var push_token = localStorage.getItem('push_notifications_token');
  if (push_token != null) {
    my_notification_delete(push_token, {
      success: function(result) {
        if (result['success'] == 1) {
          window.localStorage.removeItem("push_notifications_token");
        }
      }
    });
  }
}

function my_notification_delete(token, options) {
  try {
    options.method = 'DELETE';
    options.path = 'push_notifications/' + token;
    options.service = 'push_notifications';
    options.resource = 'push_notifications';
    Drupal.services.call(options);
  }
  catch (error) {
    console.log('push_notifications_delete - ' + token);
  }
}
